import BrandData from "@comp/AppsComponent/BrandData/page";
import ProductData from "@comp/AppsComponent/ProductData/page";
import { notFound, redirect } from "next/navigation";

async function getData(id) {
  const res = await fetch(`${process.env.NEXT_PUBLIC_API_URL}/brand/${id}`, {
    cache: "no-cache",
  });
  const post = await res.json();
  // console.log("object11", post);

  // // Check if the response status is 404
  if (post.statusCode === 404) {
    // Navigate to the custom 404 page
    return notFound(); // Exit the function
  }
  return post;
}

async function getProduct(id) {
  const res = await fetch(
    `${process.env.NEXT_PUBLIC_API_URL}/product/?page=0&brandIds=${id}`,
    {
      cache: "no-cache",
    }
  );
  const post = await res.json();

  if (post.statusCode === 404) {
    return notFound(); // Exit the function
  }
  return post;
}

export async function generateMetadata({ params }) {
  const data = await getData(params.id[0]);

  console.log("dataaaaa", data);

  const metadataUrl = new URL(
    `products/${params.id[0]}/${data?.product?.persianName}`,
    process.env.NEXT_PUBLIC_APP_URL
  );
  return {
    title: !!data?.metaTags.find((e) => e.type == "title")
      ? data?.metaTags.find((e) => e.type == "title")?.value
      : data?.persianName,
    description: !!data?.metaTags.find((e) => e.type == "description")
      ? data?.metaTags.find((e) => e.type == "description")?.value
      : ` خرید برند ${data?.persianName}| برندهای متنوع با پایین ترین قیمت | فروشگاه اینترنتی وسمه`,

    openGraph: {
      title: !!data?.metaTags.find((e) => e.type == "title")
        ? data?.metaTags.find((e) => e.type == "title")?.value
        : data?.persianName,
      description: !!data?.metaTags.find((e) => e.type == "description")
        ? data?.metaTags.find((e) => e.type == "description")?.value
        : ` خرید برند ${data?.persianName}| برندهای متنوع با پایین ترین قیمت | فروشگاه اینترنتی وسمه`,
    },
    twitter: {
      title: !!data?.metaTags.find((e) => e.type == "title")
        ? data?.metaTags.find((e) => e.type == "title")?.value
        : data?.persianName,
      description: !!data?.metaTags.find((e) => e.type == "description")
        ? data?.metaTags.find((e) => e.type == "description")?.value
        : ` خرید برند ${data?.persianName}| برندهای متنوع با پایین ترین قیمت | فروشگاه اینترنتی وسمه`,
    },
  };
}

const Page = async ({ params }) => {
  const data = await getData(params.id[0]);
  const product = await getProduct(params.id[0]);

  return (
    <>
      <BrandData params={params} data={data} product={product} />
    </>
  );
};

export default Page;
